#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivityCannonDrawCFG.h"
std::auto_ptr<M_ActivityCannonDrawCFG> M_ActivityCannonDrawCFG::msSingleton(nullptr);

int M_ActivityCannonDrawCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityCannonDrawCFGData* M_ActivityCannonDrawCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivityCannonDrawCFGData>& M_ActivityCannonDrawCFG::GetMapData()
{
	return mMapData;
}

void M_ActivityCannonDrawCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivityCannonDrawCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityCannonDrawCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mRewardItem = element->IntAttribute("RewardItem");
		data.mRewardCount = element->IntAttribute("RewardCount");
		data.mSign = element->IntAttribute("Sign");
		data.mWeight = element->IntAttribute("Weight");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivityCannonDrawCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityCannonDrawCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivityCannonDrawCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivityCannonDrawCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivityCannonDrawCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "RewardItem", data.mRewardItem);
		LuaCfgHelper::readInt(L, "RewardCount", data.mRewardCount);
		LuaCfgHelper::readInt(L, "Sign", data.mSign);
		LuaCfgHelper::readInt(L, "Weight", data.mWeight);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivityCannonDrawCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityCannonDrawCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivityCannonDrawCFG* M_ActivityCannonDrawCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityCannonDrawCFG());
	}
	return msSingleton.get();
}

void M_ActivityCannonDrawCFG::Release()
{
	msSingleton.reset(nullptr);
}
